<?php

namespace App\Factory;

use App\Exception;

class PaymentFactory {

    private $connection;
    
    public function __construct (\Doctrine\DBAL\Connection $connection) {
        $this->connection = $connection;
    }
    
    public function getReceiptType ($receipt) {
        $sql = "
            SELECT CDTIPORECE
            FROM TIPORECEINTE TP
            JOIN INTEGRACAO INTE ON TP.CDINTEGRACAO = INTE.CDINTEGRACAO
            WHERE INTE.IDINTEGRACAO = :IDINTEGRACAO
              AND UPPER(REPLACE(CDTPRECEINTE, ' ', '')) = :CDTPRECEINTE";
        
        $params = array(
            ":CDTPRECEINTE" => mb_strtoupper(preg_replace("/\s+/", "", $receipt)),
            ":IDINTEGRACAO" => "NMO"
        );
        
        $result = $this->connection->fetchAll($sql, $params);
        
        if (empty($result)) throw new Exception\ParamsException("Não foi encontrado tipo de recebimento para a origem - $receipt", 111);
        if (!isset($result[0]["CDTIPORECE"])) throw new Exception\ParamsException("Não foi encontrado tipo de recebimento para a origem - $receipt", 111);
        
        return $result[0]["CDTIPORECE"];
    }
    
}